#include "tcp.h"
//-------------------------------------------------------------
static const char *TAG = "tcp";
//-------------------------------------------------------------
typedef struct struct_recv_socket_t {
  int sock;
  unsigned char y_pos;
} struct_recv_socket;
struct_recv_socket recv_socket01;
//-------------------------------------------------------------
typedef struct
{
  unsigned char y_pos;
  unsigned char x_pos;
  char *str;
} qLCDData;
//------------------------------------------------
xQueueHandle lcd_string_queue = NULL, xQueueClose = NULL, xQueueCloseAsk = NULL;;
//------------------------------------------------
void vLCDTask(void* arg)
{
  BaseType_t xStatus;
  qLCDData xReceivedData;
  for(;;) {
    xStatus = xQueueReceive(lcd_string_queue, &xReceivedData, 10000 /portTICK_RATE_MS);
    if (xStatus == pdPASS)
    {
      LCD_SetPos(xReceivedData.x_pos,xReceivedData.y_pos);
      LCD_String(xReceivedData.str);
    }
  }
}
//------------------------------------------------
void recv_task(void *pvParameters)
{
  struct_recv_socket *arg_recv_socket;
  qLCDData xLCDData;
  arg_recv_socket = (struct_recv_socket*) pvParameters;
  char data_buffer[22] = {};
  int recv_data;
  char fl = 0;
  xLCDData.y_pos = arg_recv_socket->y_pos;
  xLCDData.str = data_buffer;
  unsigned int timeout = 1000;
  setsockopt(arg_recv_socket->sock, SOL_SOCKET, SO_RCVTIMEO, (char*)&timeout, sizeof(unsigned int));
  for(;;)
  {
    xQueueReceive(xQueueClose, &fl, 0);
    if(fl==1)
    {
      xQueueSendToBack(xQueueCloseAsk, &fl, 0);
      vTaskDelete(NULL);
    }
    recv_data = recv(arg_recv_socket->sock, data_buffer, sizeof(data_buffer), 0);
    ESP_LOGI(TAG, "recv_data: %d\n", recv_data);
    if(recv_data == -1)
    {
      ESP_LOGE(TAG, "Socket error\n");
    }
    else
    {
      for(unsigned char i=recv_data-1;i<20;i++)
        {data_buffer[i]=' ';}
      data_buffer[20] = 0;
      xQueueSendToBack(lcd_string_queue, &xLCDData, 0);
    }
  }
}
//------------------------------------------------
void tcp_task(void *pvParameters)
{
  TaskHandle_t xLCDTaskHandle = NULL, xRecvTaskHandle = NULL;
  int sockfd;
  qLCDData xLCDData;
  char str1[21];
  xLCDData.y_pos = 1;
  xLCDData.str = str1;
  struct sockaddr_in servaddr, cliaddr;
  lcd_string_queue = xQueueCreate(10, sizeof(qLCDData));
  xQueueClose = xQueueCreate(10, sizeof(unsigned char));
  xQueueCloseAsk = xQueueCreate(10, sizeof(unsigned char));
  xTaskCreate(vLCDTask, "vLCDTask", 2048, NULL, 2, &xLCDTaskHandle);
  ESP_LOGI(TAG, "Create socket...\n");
  if ( (sockfd = socket(AF_INET, SOCK_STREAM, IPPROTO_IP)) < 0 ) {
    ESP_LOGE(TAG, "socket not created\n");
    vTaskDelete(NULL);
  }
  ESP_LOGI(TAG, "Socket created");
  memset(&servaddr, 0, sizeof(servaddr));
  memset(&cliaddr, 0, sizeof(cliaddr));
  //   
  servaddr.sin_family    = AF_INET; // IPv4
  servaddr.sin_addr.s_addr = inet_addr(CONFIG_SERVER_IP);;
  servaddr.sin_port = htons(CONFIG_SERVER_PORT);
  //   
  cliaddr.sin_family    = AF_INET; // IPv4
  cliaddr.sin_addr.s_addr = INADDR_ANY;
  cliaddr.sin_port = htons(CONFIG_CLIENT_PORT);
  //    
  if (bind(sockfd, (const struct sockaddr *)&cliaddr,  sizeof(struct sockaddr_in)) < 0 )
  {
    ESP_LOGE(TAG, "socket not binded\n");
    vTaskDelete(xLCDTaskHandle);
    vQueueDelete(lcd_string_queue);
    vTaskDelete(NULL);
  }
  ESP_LOGI(TAG, "socket was binded\n");
  if (connect(sockfd, (struct sockaddr *)&servaddr,sizeof(struct sockaddr_in)) >= 0)
  {
    sprintf(str1, "Connected");
    xQueueSendToBack(lcd_string_queue, &xLCDData, 0);
    recv_socket01.y_pos = 2;
    recv_socket01.sock = sockfd;
    xTaskCreate(recv_task, "recv_task", 2048, (void*)&recv_socket01, 3, &xRecvTaskHandle);
    vTaskDelay( 2000 / portTICK_RATE_MS);
    for(int i=1; i<10; i++)
    {
      snprintf(str1, sizeof(str1), "Hello from ESP!!!\n");
      write(sockfd,(void *) str1,strlen(str1));
      vTaskDelay( 2000 / portTICK_RATE_MS);
    }
    char fl = 1;
    xQueueSendToBack(xQueueClose, &fl, 0);
    for(;;)
    {
      xQueueReceive(xQueueCloseAsk, &fl, 0);
      if(fl==1)
      {
        ESP_LOGI(TAG, "task delete\n");
        break;
      }
      vTaskDelay( 10 / portTICK_RATE_MS);
    }
  }
  close(sockfd);
  sprintf(str1, "Disonnected");
  xQueueSendToBack(lcd_string_queue, &xLCDData, 0);
  vTaskDelay(2000 / portTICK_RATE_MS);
  vTaskDelete(xLCDTaskHandle);
  vQueueDelete(lcd_string_queue);
  vTaskDelete(NULL);
}
//-------------------------------------------------------------
